#include <bits/stdc++.h>

using namespace std;

int main()
{
    long long n;
    cin >> n;
    int a[n],b[n];
    for(int i=0;i<n;i++){
        cin >> a[i];
        b[i]=a[i];
    }
    sort(b, b+n, greater<int>());
    bool t=false;
    for(int i=0;i<n;i++){
        if(a[i]!=b[i]){
            t=true;
            for(int j=n-1;j>=0;j--){
                if(a[j]==b[i]){
                    swap(a[i], a[j]);
                    break;
                }
            }
            break;
        }
    }
    if(t==false){
        bool t2=false;
        for(int i=0;i<n-1;i++){
            if(a[i]==a[i+1]){
                t2=true;
            }
        }
        if(t2==false){
            swap(a[n-2],a[n-1]);
        }
    }
    
    for(int i=0;i<n;i++){
        cout << a[i] << " ";
    }
    return 0;
}